Attribute VB_Name = "DemoVB"
Function MyEasyCallback(ByVal a As Double, ByRef b As Long, ByVal c As Byte) As Double
   MyEasyCallback = a + b + c
End Function

Function MyIIF(ByVal cond As Long, ByVal TruePart As Long, ByVal FalsePart As Long) As Double
   If cond Then MyIIF = ucEvaluate(TruePart) Else MyIIF = ucEvaluate(FalsePart)
End Function

Function MyIIFStr(ByVal cond As Long, ByVal TruePart As Long, ByVal FalsePart As Long) As String
   If cond Then MyIIFStr = ucEvaluateStr(TruePart) Else MyIIFStr = ucEvaluateStr(FalsePart)
End Function

Function MyMsgBox(ByVal Prompt As Long, ByVal Buttons As Long, ByVal Title As Long) As Long
   MyMsgBox = MsgBox(ucEvaluateStr(Prompt), Buttons, ucEvaluateStr(Title))
End Function

Function MyMsgBoxB(ByRef Prompt As String, ByVal Buttons As Long, ByRef Title As String) As Long
   MyMsgBoxB = MsgBox(Prompt, Buttons, Title)
End Function


' Callbacks using ucParam, and ucReturn are less efficient
Sub MyAverage(ByVal Expr As Long)
   Dim x As Long, Total As Double

   For x = 1 To ucParamCount(Expr)
      Total = Total + ucParamDbl(Expr, x)
   Next

   ucReturnDbl Expr, Total / ucParamCount(Expr)
End Sub

Sub MyLeft(ByVal Expr As Long)
    ucReturnStr Expr, Left$(ucParamStr(Expr, 1), ucParamDbl(Expr, 2))
End Sub

Function StringMult(ByRef MyString As String, ByVal Number As Long) As String
   Dim x As Long, TotalString As String

   For x = 1 To Number
      TotalString = TotalString + MyString
   Next

   StringMult = TotalString
End Function
